<?php
namespace Ak\Gdpr\Repository;

use Ak\Gdpr\Entity\GdprConsent;
use Ak\Orm\Repository\RepositoryInterface;
use Interop\Container\ContainerInterface;
use Laminas\Hydrator\HydratorPluginManager;
use Laminas\ServiceManager\Factory\FactoryInterface;

/**
 * Stvara novu instancu GdprConsent repozitorija.
 *
 * @package Ak\Gdpr\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/gdpr
 */
class GdprConsentRepositoryFactory implements FactoryInterface
{
    /**
     * Stvara instancu.
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return RepositoryInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $table = $container->get('db.table.gdpr');
        $hydrators = $container->get(HydratorPluginManager::class);
        $hydrator = $hydrators->get(GdprConsent::class);

        return new GdprConsentRepository($table, $hydrator);
    }
}

